<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_PackageZone StructType
 * @subpackage Structs
 */
class JP_PackageZone extends AbstractStructBase
{
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The RelStays
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfJP_RelStay
     */
    public $RelStays;
    /**
     * The Code
     * @var string
     */
    public $Code;
    /**
     * Constructor method for JP_PackageZone
     * @uses JP_PackageZone::setName()
     * @uses JP_PackageZone::setRelStays()
     * @uses JP_PackageZone::setCode()
     * @param string $name
     * @param \ArrayType\ArrayOfJP_RelStay $relStays
     * @param string $code
     */
    public function __construct($name = null, \ArrayType\ArrayOfJP_RelStay $relStays = null, $code = null)
    {
        $this
            ->setName($name)
            ->setRelStays($relStays)
            ->setCode($code);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\JP_PackageZone
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get RelStays value
     * @return \ArrayType\ArrayOfJP_RelStay|null
     */
    public function getRelStays()
    {
        return $this->RelStays;
    }
    /**
     * Set RelStays value
     * @param \ArrayType\ArrayOfJP_RelStay $relStays
     * @return \StructType\JP_PackageZone
     */
    public function setRelStays(\ArrayType\ArrayOfJP_RelStay $relStays = null)
    {
        $this->RelStays = $relStays;
        return $this;
    }
    /**
     * Get Code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param string $code
     * @return \StructType\JP_PackageZone
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        $this->Code = $code;
        return $this;
    }
}
